# Description
Play soothing sound effects to help you relax and drown out background noise. Intended to be an android port of [Blanket](https://github.com/rafaelmardojai/blanket).

# Building
Just download and import to android studio. No extra libraries should be needed.

# Adding new sounds
To add a sound called "FOO"
* Import a vector asset called `FOO.xml` to drawable. Android studio will allow you to import SVGs for this end.
* Add a line like `<string name="FOO">The Sound of FOO</string>` to strings.xml.
* Add `FOO.ogg` to the raw assets list.
* Add an entry in `credits.xml`. No really, that's not optional, the list in MainActivity.java is loaded from there.

# TODO
- [X] Import default audio assets from Blanket
- [X] Enable playback and mixing of default assets
- [X] Emergency stop button to silence everything
- [X] Implement profiles to restore state on reboot
- [X] Add credits screen to application itself
- [X] Allow importing of custom assets
- [ ] Request app be published on [F-Droid](https://f-droid.org/)

# Credits
Big thank you to [Rafael Mardojai](https://github.com/rafaelmardojai) (the author of [Blanket](https://github.com/rafaelmardojai/blanket)) and his volenteers, who designed the icons and sourced the sounds. Licences and credits for all sounds are listed in [credits.xml](app/src/main/res/raw/credits.xml).

